/*  ti_link - link program for TI calculators
 *  Copyright (C) 1999, 2000  Romain Lievin
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef GCALLDBOX_H
#define GCALLDBOX_H

#include <gtk/gtk.h>
#include "defines.h"

/****************************/
/* General use dialog boxes */
/****************************/
void user_box_b1(GtkWidget *widget, int *i);
void user_box_b2(GtkWidget *widget, int *i);
void user_box_b3(GtkWidget *widget, int *i);

/********************/
/* Entry dialog bow */
/********************/
void entry_ok(GtkWidget *widget, struct edb *s);
void entry_cancel(GtkWidget *widget, struct edb *s);

/*********************************************************/
/* Hardware&calc dialog box: ok, cancel and help buttons */
/*********************************************************/
void setup_config_ok(GtkButton *button, struct hcdb *h);
void setup_config_cancel(GtkButton *button, struct hcdb *h);
void setup_config_help(GtkButton *button, struct hcdb *h);

/***************************************************/
/* Callbacks called for the setup delay dialog box */
/***************************************************/
void setup_delay_ok(GtkWidget *widget, struct dtdb *s);
void setup_delay_cancel(GtkWidget *widget, struct dtdb *s);

/*****************************************************/
/* Callbacks called for the setup timeout dialog box */
/*****************************************************/
void setup_timeout_ok(GtkWidget *widget, struct dtdb *s);
void setup_timeout_cancel(GtkWidget *widget, struct dtdb *s);

/******************************************************/
/* Callbacks called for the general config dialog box */
/******************************************************/
void gdb_button1_clicked                     (GtkButton       *button, struct gdb *s);
void gdb_button2_clicked                     (GtkButton       *button, struct gdb *s);
void gdb_button3_clicked                     (GtkButton       *button, struct gdb *s);

/*****************************************************/
/* Callbacks called for the screen setup  dialog box */
/*****************************************************/
void setup_screen_ok(GtkWidget *widget, struct ssdb *s);
void setup_screen_cancel(GtkWidget *widget, struct ssdb *s);

#endif
